import 'package:ffi_helper/ffi_helper.dart';
import 'package:test/test.dart';

void main() {
  test('Get slices of Arena', () {
    final arena = Arena(10, Uint8Array.fromPtr);
    expect(arena.freeSpace, 10);
    final slice1 = arena.newArray(5);
    expect(slice1.view.length, 5);
    expect(arena.freeSpace, 5);
    final slice2 = arena.newArray(5);
    expect(slice2.view.length, 5);
    expect(arena.freeSpace, 0);
    arena.delete();
  });

  test('throws RangeError when overflow', () {
    final arena = Arena(8, Uint8Array.fromPtr);
    arena.newArray(5);
    expect(() => arena.newArray(5), throwsRangeError);
    arena.delete();
  });
}
